var city_list = [];
var key = '';
var timeID = null;
function getCity() {
    $.ajax({
        url: '/api/index/getCity',
        data: {
            limit: 1000
        },
        success: function (res) {
            city_list = res.list;
            var html = '';
            for(var i=0;i<12;i++){
                html+='<li class="city_name"><a href="/news.html?city_name='+city_list[i].name
                html+='">'+city_list[i].name+'</a></li>'
            }
            $('#city-box').html(html)
        }
    })
}
function getNav(){
    $.ajax({
        url: '/api/index/getNav',
        success: function (res) {
            console.log(res)
            var classify = res.classify
            var cHtml = '';
            for(var i=0;i<classify.length;i++){
                var child = classify[i].child;
                cHtml+='<div class="left-item">'
                if(child){
                    cHtml+='<h5 class="h5_nav"><span>'+classify[i].name+'</span><i>></i></h5><ul>'
                        for(var l=0;l<child.length;l++){
                            cHtml+='<li><a href="/news.html?type_id='+child[l].id+'">'+child[l].name+'</a></li>'
                        }
                    
                }else{
                    cHtml+='<h5 class="h5_nav"><a href="/news.html?type_id='+classify[i].id+'">'+classify[i].name+'</a><i>></i></h5><ul>'
                }
                cHtml+='</ul></div>'
            }
            $('#nav-box').append(cHtml)


            var exam = res.exam;
            var aHtml = '';
            for (const key in exam) {
                aHtml+='<h3>'+key+'</h3>'
                for(var i =0;i<exam[key].length;i++){
                    aHtml+='<a href="'+exam[key][i].url+'" class="clearfix">'
                    aHtml+='<div class="icon-box"><img src="'+exam[key][i].icon+'" alt="">'
                    aHtml+='</div><div class="fl"><h5>'+exam[key][i].title+'</h5>'
                    aHtml+='<p>'+exam[key][i].describe+'</p></div></a>'
                }
                aHtml+='<div class="empty"></div>'
            }
            $('#app-box').html(aHtml)
            var article = res.article;
            var hHtml='';
            for(var i=0;i<article.length;i++){
                hHtml+='<li><a href="'+article[i].url+'" class="clearfix">'
                hHtml+='<p class="fl">'+article[i].a_title+'</p>'
                hHtml+='<span class="fr">'+article[i].create_time.substring(0,10)+'</span></a></li>'
            }
            $('#hot-box').html(hHtml)
            
            
        }
    })
}
function retrievalCity() {
    if (!key) {
        return $('.search-list').hide()
    }
    var html = ''
    var nodata = '<li class="no-data">没搜到相关城市</li>'
    for (var i = 0; i < city_list.length; i++) {
        if (city_list[i].name.includes(key)) {
            html += '<li onclick="selectCity(\'' + city_list[i].name + '\')">' + city_list[i].name + '</li>'
        }
    }
    if (html) {
        $('.search-list').html(html)
    } else {
        $('.search-list').html(nodata)
    }
    $('.search-list').show()
}
function selectCity(name) {
    $('#city').val(name)
    $('.search-list').hide()
}
function searchKey() {
    location.href = '/news.html?city_name=' + $('#city').val().replace(/[^\u4e00-\u9fa5]/g, '')
}
$(function () {
    getNav()
    getCity()
    $('#city').bind("input", function () {
        var str = $('#city').val().replace(/[^\u4e00-\u9fa5]/g, '');
        if (str != key) {
            key = str
            clearTimeout(timeID)
            timeID = setTimeout(function () {
                retrievalCity()
            }, 300)
        }
    })

})