(function($) {
	$.fn.extend({
				mcPaginate : function(options) {
					
					var defaults = {
						href:"",
						pageSize : 10,
						pageNo : 1,
						pageCount : 0,
						otherParam:null,
						display:5
					};
					var opts = $.extend(defaults, options);
					//局部变量
					var href = opts.href;
					console.log(href)
					var pageCount = opts.pageCount;
					var pageSize = opts.pageSize;
					var pageNo = opts.pageNo;
					var otherParam = opts.otherParam;
					var display = opts.display;// 显示多少个 分页连接
					var hrefTemp=opts.href;
					var $pageDiv = $(this);
					
					//拼接其他的参数
					if (typeof otherParam != 'undefined' && otherParam != "" && otherParam!= null) {
							hrefTemp = hrefTemp + $.fn.splitOtherParam(otherParam);
					}
					
					if (pageCount <= 1) {
						return;//不用分页
					}
 
					$pageDiv.append("共" + pageCount + "页");
					// 上一页
					if (pageNo > 1) {
						href = hrefTemp + "&page=" + (pageNo - 1);
						$pageDiv.append("<a href='" + href
								+ "' style='width: 65px;'>" + "上一页" + "</a>");
					};
 
					//分页区域
					if (pageCount <= display) {
						//总页数 < 显示页数
						for ( var i = 0; i < pageCount; i++) {
							href = hrefTemp + "&page=" + (i + 1);
							if (pageNo == (i + 1)) {// 当前页
								$pageDiv.append("<a href='" + href
										+ "' class='pageCurrent'>" + pageNo
										+ "</a>");
							} else {
								$pageDiv.append("<a href='" + href + "'>"
										+ (i + 1) + "</a>");
							};
						}
						
					} else {
						var midIndex = 0;
						var firstPageNum = pageNo - midIndex;
						var lastPageNum = pageNo + midIndex - 1;
						
						if (display % 2 == 0) {
							midIndex = display / 2;
						} else {
							midIndex = display / 2 + 1;
						}
						if (firstPageNum < 1) {
							firstPageNum = 1;
						}
						if (lastPageNum < display) {
							lastPageNum = display;
						}
						if (lastPageNum > pageCount) {
							lastPageNum = pageCount;// 超过pageCount
							firstPageNum = pageCount - display + 1;
						}
 
						for ( var j = firstPageNum; j < lastPageNum + 1; j++) {
							href = hrefTemp + "&page=" + j;
							if (pageNo == j) {// 当前页
								$pageDiv
										.append("<a href='" + href
												+ "' class='pageCurrent'>" + j
												+ "</a>");
							} else {
								$pageDiv.append("<a href='" + href + "'>" + j
										+ "</a>");
							}
							;
						}
 
					}
 
					// 下一页
					if (pageNo < pageCount) {
						href = hrefTemp + "&page=" + (pageNo + 1);
						$pageDiv.append("<a href='" + href
								+ "' style='width: 65px;'>" + "下一页" + "</a>");
					}
					;
 
					/* if(pageCount > display){ */
					$pageDiv
							.append("转到"
									+ "<input type='text' class='goNum' style='width:30px;' name='goNum'>页<input type='button' name='goButton' class='goButton' value='确定'>");
					$(".goButton").click(
							function() {
								var goNum = $(".goNum").val();
								if (goNum != "") {
									window.location.href = hrefTemp
											+ "&page=" + goNum;
								}
							});
					/*}*/
 
					$("#page a").hover(function() {
						$(this).addClass("hover");
					}, function() {
						$(this).removeClass("hover");
					});
 
				}
			});
 
	//把参数拼接成字符串
	$.fn.splitOtherParam = function(obj){
					var temp = "";
					  for ( var p in obj ){ 
						  if ( typeof ( obj [ p ]) == " function " ){ 
							  obj [ p ]() ; 
						  } else { 
							  temp = temp +"&"+p+"="+obj[p];
						  } 
					  } 
					  return temp;
	};
	
	
})(jQuery);